<template>
    <div style="width:100%;height:100%;" id="terminal"></div>
</template>

<script>
import { Terminal } from 'xterm'
import { FitAddon } from 'xterm-addon-fit'
import eventBus from "@/assets/js/EventBus";

export default {
    props:{
      pid:{
        type:Number,
        required:true,
        default:9
      },
      uid:{
        type:Number,
        required:true,
        default:9
      }
    },
    name: 'webssh',
    data () {
      return {
        term: null,
        order:'',
      }
    },
    methods: {
      recvMessage(res){
        //将传回来的数据显示在xterm里
        this.term.write(res.data);
        //重置要发送的信息
        this.order = ""
      }
    },
    beforeUpdate(){
      resizeScreen()
    },
    mounted () {
      const initMsg = JSON.stringify({func:"docker",type:'init',uid:this.uid,pid:this.pid})
      eventBus.emit("socketSend",initMsg)
      eventBus.on("socketRecvDocker",recvMessage)
      let terminalContainer = document.getElementById('terminal')
      //创建xterm实例
      this.term = new Terminal({
        rendererType: 'canvas', // 渲染类型
        rows: 10, // 行数
        convertEol: true, // 启用时，光标将设置为下一行的开头
        scrollback: 10, // 终端中的回滚量
        disableStdin: false, // 是否应禁用输入。
        cursorStyle: 'bar', // 光标样式
        cursorBlink: true, // 光标闪烁
        theme: {
          foreground: 'black', // 字体
          background: 'white', // 背景色
          cursor: 'black' // 设置光标
        }
      })                     // 创建一个新的Terminal对象



      const fitAddon = new FitAddon()
      this.term.loadAddon(fitAddon)
      fitAddon.fit()
      window.addEventListener("resize", resizeScreen)
      function resizeScreen() {
        try { // 窗口大小改变时，触发xterm的resize方法使自适应
          fitAddon.fit()
        } catch (e) {
          console.log("resizeScreen error", e)
        }
      }

      this.term.open(terminalContainer)              // 将term挂载到dom节点上
      this.term.prompt = _ => {
        this.term.write("\r\n$ ")
      }
      //在xterm上显示命令行提示
      //this.term.prompt()
      //监听xterm的键盘事件
      
      this.term.onData(async key => {
        const data  = JSON.stringify({func:"docker",type:'opt',opt:key})
        eventBus.emit("socketSend",data)
      })
        resizeScreen()
    }
  }
</script>
<style scoped>
@import 'xterm/css/xterm.css'
</style>